# API Index

Vaulted Method | Vault API (/v1)
-------------- | ---------------
[getInitStatus](./init.md#module_init..getInitStatus) | GET `sys/init`
[init](./init.md#module_init..init) | PUT `sys/init`
[getSealedStatus](./seal.md#module_seal..getSealedStatus) | GET `sys/seal-status`
[seal](./seal.md#module_seal..seal) | PUT `sys/seal`
[unSeal](./seal.md#module_seal..unSeal) | PUT `sys/unseal`
[getMounts](./mounts.md#module_mounts..getMounts) | GET `sys/mounts`
[deleteMount](./mounts.md#module_mounts..deleteMount) | DELETE `sys/mounts/:id`
[createMount](./mounts.md#module_mounts..createMount) | POST `sys/mounts/:id`
[reMount](./mounts.md#module_mounts..reMount) | POST `sys/remount`
[getAuditMounts](./audit.md#module_audit..getAuditMounts) | GET `sys/audit`
[enableAudit](./audit.md#module_audit..enableAudit) | PUT `sys/audit/:id`
[disableAudit](./audit.md#module_audit..disableAudit) | DELETE `sys/audit/:id`
[enableFileAudit](./audit.md#module_audit..enableFileAudit) | PUT `sys/audit/:id`
[enableSyslogAudit](./audit.md#module_audit..enableSyslogAudit) | PUT `sys/audit/:id`
[getPolicies](./policy.md#module_policy..getPolicies) | GET `sys/policy`
[getPolicy](./policy.md#module_policy..getPolicy) | GET `sys/policy/:id`
[createPolicy](./policy.md#module_policy..createPolicy) | PUT `sys/policy/:id`
[deletePolicy](./policy.md#module_policy..deletePolicy) | DELETE `sys/policy/:id`
[getLeader](./leader.md#leadergetinitstatus--promise) | GET `sys/leader`
[checkHealth](./health.md#healthcheckhealthoptions--promise) | GET `sys/health`
[getKeyStatus](./keys.md#module_keys..getKeyStatus) | GET `sys/key-status`
[rotateKey](./keys.md#module_keys..rotateKey) | PUT `sys/rotate`
[getRekeyStatus](./keys.md#module_keys..getRekeyStatus) | GET `sys/rekey/init`
[startRekey](./keys.md#module_keys..startRekey) | PUT `sys/rekey/init`
[stopRekey](./keys.md#module_keys..stopRekey) | DELETE `sys/rekey/init`
[updateRekey](./keys.md#module_keys..updateRekey) | PUT `sys/rekey/update`
[renewLease](./leases.md#module_leases..renewLease) | PUT `sys/renew/:id`
[revokeLease](./leases.md#module_leases..revokeLease) | PUT `sys/revoke/:id`
[revokeLeasePrefix](./leases.md#module_leases..revokeLeasePrefix) | PUT `sys/revoke-prefix/:id`
[getAuthMounts](./auth.md#module_auth..getAuthMounts) | GET `sys/auth`
[deleteAuthMount](./auth.md#module_auth..deleteAuthMount) | DELETE `sys/auth/:id`
[createAuthMount](./auth.md#module_auth..createAuthMount) | POST `sys/auth/:id`
[createToken](./auth/token.md#module_auth/token..createToken) | POST `auth/token/create`
[renewToken](./auth/token.md#module_auth/token..renewToken) | POST `auth/token/renew/:id`
[lookupToken](./auth/token.md#module_auth/token..lookupToken) | GET `auth/token/lookup/:id`
[revokeToken](./auth/token.md#module_auth/token..revokeToken) | POST `auth/token/revoke/:id`
[revokeTokenOrphan](./auth/token.md#module_auth/token..revokeTokenOrphan) | POST `auth/token/revoke-orphan/:id`
[revokeTokenPrefix](./auth/token.md#module_auth/token..revokeTokenPrefix) | POST `auth/token/revoke-prefix/:id`
[lookupTokenSelf](./auth/token.md#module_auth/token..lookupTokenSelf) | GET `auth/token/lookup-self`
[revokeTokenSelf](./auth/token.md#module_auth/token..revokeTokenSelf) | POST `auth/token/revoke-self`
[getApp](./auth/appid.md#module_auth/appid..getApp) | GET `auth/app-id/map/app-id/:id`
[createApp](./auth/appid.md#module_auth/appid..createApp) | POST `auth/app-id/map/app-id/:id`
[deleteApp](./auth/appid.md#module_auth/appid..deleteApp) | DELETE `auth/app-id/map/app-id/:id`
[getUser](./auth/appid.md#module_auth/appid..getUser) | GET `auth/app-id/map/user-id/:id`
[createUser](./auth/appid.md#module_auth/appid..createUser) | POST `auth/app-id/map/user-id/:id`
[deleteUser](./auth/appid.md#module_auth/appid..deleteUser) | DELETE `auth/app-id/map/user-id/:id`
[appLogin](./auth/appid.md#module_auth/appid..appLogin) | POST `auth/app-id/login`
[read](./secret.md#module_secret..read) | GET `secret/:id`
[write](./secret.md#module_secret..write) | PUT `secret/:id`
[delete](./secret.md#module_secret..delete) | DELETE `secret/:id`
[readCubby](./backends/cubbyhole.md#module_cubbyhole..readCubby) | GET `cubbyhole/:id`
[writeCubby](./backends/cubbyhole.md#module_cubbyhole..writeCubby) | PUT `cubbyhole/:id`
[deleteCubby](./backends/cubbyhole.md#module_cubbyhole..deleteCubby) | DELETE `cubbyhole/:id`
[configConsulAccess](./backends/consul.md#module_backend/consul..configConsulAccess) | POST `consul/config/access`
[getConsulRole](./backends/consul.md#module_backend/consul..getConsulRole) | GET `consul/roles/:id`
[createConsulRole](./backends/consul.md#module_backend/consul..createConsulRole) | POST `consul/roles/:id`
[deleteConsulRole](./backends/consul.md#module_backend/consul..deleteConsulRole) | DELETE `consul/roles/:id`
[generateConsulRoleToken](./backends/consul.md#module_backend/consul..generateConsulRoleToken) | GET `consul/creds/:id`
[getCaDer](./backends/pki.md#backendpkigetcadermountname--promise) | GET `pki/ca`
[getCaPem](./backends/pki.md#backendpkigetcapemmountname--promise) | GET `pki/ca/pem`
[getCertCa](./backends/pki.md#backendpkigetcertcamountname--promise) | GET `pki/cert/ca`
[getCertCrl](./backends/pki.md#backendpkigetcertcrlmountname--promise) | GET `pki/cert/crl`
[getCertSerial](./backends/pki.md#backendpkigetcertserialoptions-mountname--promise) | GET `pki/cert/:id`
[setConfigCa](./backends/pki.md#backendpkisetconfigcamountname--promise) | POST `pki/config/ca`
[getConfigCrl](./backends/pki.md#backendpkigetconfigcrlmountname--promise) | GET `pki/config/crl`
[setConfigCrl](./backends/pki.md#backendpkisetconfigcrlmountname--promise) | POST `pki/config/crl`
[getConfigUrls](//docs/backends/pki.md#backendpkigetconfigurlsmountname--promise) | GET `pki/config/urls`
[setConfigUrls](./backends/pki.md#backendpkisetconfigurlsmountname--promise) | POST `pki/config/urls`
[getCrlDer](./backends/pki.md#backendpkigetcrldermountname--promise) | GET `pki/crl`
[getCrlPem](./backends/pki.md#backendpkigetcrlpemmountname--promise) | GET `pki/crl/pem`
[getCrlRotate](./backends/pki.md#backendpkigetcrlrotatemountname--promise) | GET `pki/crl/rotate`
[genIntermediatesExported](./backends/pki.md#backendpkigenintermediatesexportedmountname--promise) | POST `pki/intermediate/generate/exported`
[genIntermediatesInternal](./backends/pki.md#backendpkigenintermediatesinternalmountname--promise) | POST `pki/intermediate/generate/internal`
[setSignedIntermediates](./backends/pki.md#backendpkisetsignedintermediatesmountname--promise) | POST `pki/intermediate/set-signed`
[issueCertCredentials](./backends/pki.md#backendpkiissuecertcredentialsmountname--promise) | POST `pki/issue/:id`
[revokeCertCredentials](./backends/pki.md#backendpkirevokecertcredentialsmountname--promise) | POST `pki/revoke`
[createCertRole](./backends/pki.md#backendpkicreatecertroleoptions-mountname--promise) | POST `pki/roles/:id`
[getCertRole](./backends/pki.md#backendpkigetcertroleoptions-mountname--promise) | GET `pki/roles/:id`
[deleteCertRole](./backends/pki.md#backendpkideletecertroleoptions-mountname--promise) | DELETE `pki/roles/:id`
[genRootExported](./backends/pki.md#backendpkigenrootexportedmountname--promise) | POST `pki/root/generate/exported`
[genRootInternal](./backends/pki.md#backendpkigenrootinternalmountname--promise) | POST `pki/root/generate/internal`
[signIntermediateWithRoot](./backends/pki.md#backendpkisignintermediatewithrootmountname--promise) | POST `pki/root/sign-intermediate`
[signCertificate](./backends/pki.md#backendpkisigncertificateoptions-mountname--promise) | POST `pki/sign/:id`
[signCertificateVerbatim](./backends/pki.md#backendpkisigncertificateverbatimmountname--promise) | POST `pki/sign-verbatim`
